Index: code/trunk/src/orxonox/core/ArgReader.h
===================================================================
--- code/trunk/src/orxonox/core/ArgReader.h	(revision 790)
+++ code/trunk/src/orxonox/core/ArgReader.h	(revision 790)
@@ -0,0 +1,62 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Benjamin Knecht <beni_at_orxonox.net>
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file  Argreader.h
+ @brief reads arguments
+ @author Benjamin Knecht <beni_at_orxonox.net>
+ */
+
+#ifndef _ArgReader_H__
+#define _ArgReader_H__
+
+#include <string>
+
+#include "CorePrereqs.h"
+
+namespace orxonox {
+
+  class _CoreExport ArgReader
+  {
+    public:
+      ArgReader(int argc, char **argv);
+      void checkArgument(std::string option, std::string& string, bool must=false);
+      void checkArgument(std::string option, int& integer, bool must=false);
+      void checkArgument(std::string option, float& floating, bool must=false);
+      bool errorHandling();
+    private:
+      int checkOption(std::string option);
+
+    private:
+      int counter_;
+      char **arguments_;
+      bool fail_;
+      std::string errorStr_;
+  };
+
+}
+#endif /* _ArgReader_H__ */
Index: code/trunk/src/orxonox/core/BaseObject.cc
===================================================================
--- code/trunk/src/orxonox/core/BaseObject.cc	(revision 790)
+++ code/trunk/src/orxonox/core/BaseObject.cc	(revision 790)
@@ -0,0 +1,66 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      ...
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file BaseObject.cc
+    @brief Implementation of the BaseObject class.
+*/
+
+#include "util/tinyxml/tinyxml.h"
+
+#include "BaseObject.h"
+
+namespace orxonox
+{
+    CreateFactory(BaseObject);
+
+    /**
+        @brief Constructor: Registers the object in the BaseObject-list.
+    */
+    BaseObject::BaseObject()
+    {
+        RegisterRootObject(BaseObject);
+    }
+
+    /**
+        @brief Destructor
+    */
+    BaseObject::~BaseObject()
+    {
+    }
+
+    /**
+        @brief load general xml paramters
+    */
+    void BaseObject::loadParams(TiXmlElement* xmlElem)
+    {
+        if (xmlElem->Attribute("name"))
+        {
+            this->setName(xmlElem->Attribute("name"));
+        }
+    }
+}
Index: code/trunk/src/orxonox/core/BaseObject.h
===================================================================
--- code/trunk/src/orxonox/core/BaseObject.h	(revision 790)
+++ code/trunk/src/orxonox/core/BaseObject.h	(revision 790)
@@ -0,0 +1,29 @@
+/*!
+    @file BaseObject.h
+    @brief Definition of the BaseObject class.
+
+    The BaseObject is the parent of all classes representing an instance in the game.
+*/
+
+#ifndef _BaseObject_H__
+#define _BaseObject_H__
+
+#include "CorePrereqs.h"
+#include "util/tinyxml/TinyXMLPrereqs.h"
+
+#include "CoreIncludes.h"
+
+namespace orxonox
+{
+    //! The BaseObject is the parent of all classes representing an instance in the game.
+    class _CoreExport BaseObject : virtual public OrxonoxClass
+    {
+        public:
+            BaseObject();
+            virtual ~BaseObject();
+            virtual void loadParams(TiXmlElement* xmlElem);
+    };
+    ExportClass(BaseObject, Core);
+}
+
+#endif /* _BaseObject_H__ */
Index: code/trunk/src/orxonox/core/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/core/CMakeLists.txt	(revision 790)
+++ code/trunk/src/orxonox/core/CMakeLists.txt	(revision 790)
@@ -0,0 +1,22 @@
+SET( CORE_SRC_FILES
+  BaseObject.cc
+  Factory.cc
+  IdentifierList.cc
+  Identifier.cc
+  MetaObjectList.cc
+  OrxonoxClass.cc
+  ConfigValueContainer.cc
+  Error.cc
+  SignalHandler.cc
+  ArgReader.cc
+  DebugLevel.cc
+  OutputHandler.cc
+  Language.cc
+)
+
+ADD_LIBRARY( core SHARED ${CORE_SRC_FILES})
+SET_TARGET_PROPERTIES( core PROPERTIES LINK_FLAGS "--no-undefined" )
+
+TARGET_LINK_LIBRARIES( core
+  util
+)
Index: code/trunk/src/orxonox/core/ClassFactory.h
===================================================================
--- code/trunk/src/orxonox/core/ClassFactory.h	(revision 265)
+++ code/trunk/src/orxonox/core/ClassFactory.h	(revision 790)
@@ -1,6 +1,46 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/*!
+    @file ClassFactory.h
+    @brief Definition and implementation of the ClassFactory class
+
+    The ClassFactory is able to create new objects of a specific class.
+*/
+
 #ifndef _ClassFactory_H__
 #define _ClassFactory_H__
 
+#include <string>
+
+#include "CorePrereqs.h"
+
+#include "Factory.h"
 #include "Identifier.h"
+#include "Debug.h"
 
 namespace orxonox
@@ -9,35 +49,38 @@
     // ###      ClassFactory       ###
     // ###############################
+    //! The ClassFactory is able to create new objects of a specific class.
     template <class T>
     class ClassFactory : public BaseFactory
     {
         public:
-            static bool create();
+            static bool create(const std::string& name);
             BaseObject* fabricate();
 
         private:
-            ClassFactory() {}
-            ClassFactory(const ClassFactory& factory) {}
-            ~ClassFactory() {}
+            ClassFactory() {}                               // Don't create
+            ClassFactory(const ClassFactory& factory) {}    // Don't copy
+            virtual ~ClassFactory() {}                      // Don't delete
 
             static T* createNewObject();
     };
 
+    /**
+        @brief Adds the ClassFactory to the Identifier of the same type and the Identifier to the Factory.
+        @return Always true (this is needed because the compiler only allows assignments before main())
+    */
     template <class T>
-    bool ClassFactory<T>::create()
+    bool ClassFactory<T>::create(const std::string& name)
     {
+        COUT(4) << "*** Create entry for " << name << " in Factory." << std::endl;
         ClassIdentifier<T>::getIdentifier()->addFactory(new ClassFactory<T>);
-
-        ClassIdentifier<T>::getIdentifier()->startCreatingHierarchy();
-#if HIERARCHY_VERBOSE
-        std::cout << "*** Create Factory -> Create Class\n";
-#endif
-        BaseObject* temp = ClassIdentifier<T>::getIdentifier()->fabricate();
-        delete temp;
-        ClassIdentifier<T>::getIdentifier()->stopCreatingHierarchy();
+        Factory::add(name, ClassIdentifier<T>::getIdentifier());
 
         return true;
     }
 
+    /**
+        @brief Creates and returns a new object of class T.
+        @return The new object
+    */
     template <class T>
     BaseObject* ClassFactory<T>::fabricate()
@@ -46,4 +89,8 @@
     }
 
+    /**
+        @brief Creates and returns a new object of class T; this is a wrapper for the new operator.
+        @return The new object
+    */
     template <class T>
     T* ClassFactory<T>::createNewObject()
@@ -53,3 +100,3 @@
 }
 
-#endif
+#endif /* _ClassFactory_H__ */
